<?php
class SystemAllLicensesController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	var $components = array ('Pagination', 'Lv','Check');
	var $uses=array('Configure','Validation','License','Host','Poll','Validation','Version','Someauth','Authority','Somemod','Module');
	var $layout='system';
	//    var $pageTitle = 'LVシステム管理/全体設定/ライセンス';

	function beforeFilter()
	{
		// $this->Configure->write('debug',0);
		if(in_array($this->params['action'], array("check_lic"))){
		}
		else{
			parent::beforeFilter();
		}
	}
	function index($a=null)
	{
		$this->requestAction("system_all_licenses/check_lic/");
		//-----pageTitle--------
		$lv_system_manage=__('lv_system_manage',$retrun=true);
		$all_setting=__('all_setting',$retrun=true);
		$license=__('license',$retrun=true);
		$this->pageTitle = __('title',$return = true);
		//-----pageTitle--------
		if($a==1){
			$this->layout='ajax';
		}

		$fields1 = 'licence_code';
		$licence_code = $this->License->find(null,$fields1,'id DESC','1',null);
		$fields2 = 'update_time';
		$update_time = $this->License->find(null,$fields2,'id DESC','1',null);
		$Version = $this->Version->find(array("type_id" => "2"),'version',null,'1',null);
		//xinw start 20080307
		$Version_release = $this->Version->find(array("type_id" => "0"),'version',null,'1',null);
		$Version_db = $this->Version->find(array("type_id" => "1"),'version',null,'1',null);
		//xinw end 20080307

		$this->set('Version',$Version);
		//xinw start 20080307
		$this->set('Version_release',$Version_release);
		$this->set('Version_db',$Version_db);
		//xinw end 20080307
		//    	var_dump($licence_code);
		if(!empty($licence_code)){
			$code=$licence_code['License']['licence_code'];
			$t = $update_time['License']['update_time'];

			$time = date("Y/m/d H:i:s",strtotime($t));

			$this->set('time',$time);
			//         $conditions_Poll = array('1=1')  ;
			$conditions_Poll = array('Poll.id != 0 AND Poll.status != 6');
			//         $conditions_Poll = array('Poll.id != 0 AND Poll.status != 0');
			//    	$host_no = $this->Host->findCount(array('Host.status != 0'), $recursive = 0);
			$host_no = $this->Host->findCount(array('Host.status != 1'), $recursive = 0);
			$poll_no = $this->Poll->findCount($conditions_Poll, $recursive = 0);
			if(empty($code)){
				$poll_no=0;
			}
			$this->set('poll_no',$poll_no);
			$this->set('host_no',$host_no);

			$result = $this->decode($code);
			//        $result = exec( 'C:\Apache2.2\htdocs\vendors\decode 9BB9AE73360FA66A3A94D7016EFB544C4109E7EB5C9C56E8' );
			//        $result = system($toexec);

			$results = explode(" ", $result);

			$this->set('result',$results);

			$year=$results[5];
			$day=$results[6];
			//時間は問題があります








			//        $d='1';
			//        $y='2007';
			//        $date = date("Y/m/d", mktime(0, 0, 0, 0, $d, $y));

			$date = date("Y/m/d", mktime(0, 0, 0, 1, $day+1, $year));

			//        echo "date=>".$date;
			$this->set('date',$date);
			$assets=__('function_assets',$retrun=true);
			$oper=__('function_oper',$retrun=true);
			$use=__('function_use',$retrun=true);
			$option=__('function_option',$retrun=true);

			$available=__('available',$return=true);
			$Basic=__('Basic',$return=true);

			$use_option =__('license_use_option',true);
			$assets_option =__('license_assets_option',true);
			$oper_option =__('license_oper_option',true);
			$update_option =__('license_update_option',true);
			$NETMETRIX =__('license_NETMETRIX',true);
			//jinl start 20080331
			$license_URL_option =__('license_URL_option',true);
			//jinl end 20080331
			$this->set('available',$available);
			$this->set('Basic',$Basic);

			if($results[1]==255){
				$this->set('use',$use);
			}
			if($results[2]==255){
				$this->set('assets',$assets);
			}
			if($results[3]==255){
				$this->set('oper',$oper);
			}
			if($results[4]==255){
				$this->set('option',$option);
			}
			if(($results[4] & 0x01) != 0){
				$this->set('license_use_option',$use_option);
			}//稼動管理








			if(($results[4] & 0x02) != 0){
				$this->set('license_assets_option',$assets_option);
			} //資産管理





			if(($results[4] & 0x04) != 0){
				$this->set('license_oper_option',$oper_option);
			}//操作管理2^3
			if(($results[4] & 0x20) != 0){
				$this->set('license_update_option',$update_option);
			}//ファイル更新履歴2^5
			if(($results[4] & 0x40) != 0){
				$this->set('license_NETMETRIX',$NETMETRIX);
			}//NETMETRIX-LogVilalge 共有 2^6
			
			
			//jinl start 20080331
			if(($results[4] & 0x08) != 0){//URLカテゴリ履歴 共有 2^3
				$this->set('license_URL_option',$license_URL_option);
			}//URLカテゴリ履歴
			//jinl end 20080331

		}
		else{
			$this->set('result',null);
			$this->set('poll_no',null);
			$this->set('host_no',null);
			$this->set('date',null);
			$this->set('time',null);
			$this->set('available',null);
			$this->set('use_option',null);
			$this->set('assets_option',null);
			$this->set('oper_option',null);
			$this->set('update_option',null);
			$this->set('NETMETRIX',null);
			$this->set('Basic',null);
		}

		$this->render('index');
	}

	function update($f=null)
	{   //-----pageTitle--------
		$lv_system_manage=__('lv_system_manage',$retrun=true);
		$all_setting=__('all_setting',$retrun=true);
		$license=__('license',$retrun=true);
		$this->pageTitle =$lv_system_manage."/".$all_setting."/".$license;
		//-----pageTitle--------
		//      $a=0;
		//         if($a!=1){
		$this->layout='ajax';
		//         }

		$errorMessage = array();
		$license_code  = $this->data['License']['licence_code'];//data=licence_code;po=license_code

		if($f!='init'){
			if(!$this->Validation->maxLength($license_code,70)){
				$errorMessage['license_code'][] = 'E-00300';
				$this->layout='system';
			}
			if(!$this->Check->checkAllHalf($license_code)){
				$errorMessage['license_code'][] = 'E-00400';
				$this->layout='system';
			}

			if($this->Lv->is_empty($license_code)){
				$errorMessage['license_code'][] = 'E-00100';
				//	          		$a=1;
				$this->layout='system';
			}

			$v_path=(VENDORS);

			$result = $this->decode($license_code);

			$results = explode(" ", $result);
			//	     debug($results,true);
			if($result=="-1"){
				$errorMessage['license_code'][] = 'E-01500';
				$this->layout='system';
			}else if(count($results) < 9){
				$errorMessage['license_code'][] = 'E-01500';
				$this->layout='system';
			}
		}
		$this->set('errorMessage',$errorMessage);

		if(empty($errorMessage)){
			if($f==1){
				// dele Someauths && Somemods
				//	          	 $Someauths = $this->Someauth->findAll(null,'id',null,'0',null,null);
				//    	         $Somemods = $this->Somemod->findAll(null,null,null,'0',null,null);
				//				 if(!empty($Someauths)){
				//				 	foreach ($Someauths as $Someauth) {
				//				 	$this->Someauth->del($Someauth['Someauth']['id']);
				//				    }
				//				 }
				//				 if(!empty($Somemods)){
				//				 	foreach ($Somemods as $Somemod) {
				//				 	$this->Somemod->del($Somemod['Somemod']['id']);
				//				    }
				//				 }
				$this->Someauth->deleteAll(array('1=1'));
				$this->Somemod->deleteAll(array('1=1'));
				//
				//	          	 //-------add someauths start--------------
				////			         if($results[1]==255){
				//			          	 $m_assets =02255;
				//			          	 $md_assets=md5($m_assets);
				////			          }
				////			          else{
				////			          	 $md_assets="0";
				////			          }
				////			          if($results[2]==255){
				//			          	 $m_oper =03255;
				//			          	 $md_oper=md5($m_oper);
				////					  }
				////					  else{
				////			          	 $md_oper="0";
				////			          }
				////					  if($results[3]==255){
				//			          	 $m_use =04255;
				//			          	 $md_use=md5($m_use);
				////			          }
				////			          else{
				////			          	$md_use = "0";
				////			          }
				//			         $condition = "'".$md_assets."'".","."'".$md_oper."'".","."'".$md_use."'";

				////////////////////////////////set without table
				////////////add by wzy
				//		    2 application
				//          3 device
				//          4 performance
				//          6 service
				//          7 fileinfo
				//          8 antivirus
				//          9 event
				//         12 webaccess
				//         13 WMI

				$modules = array(
				'filetransfer',
				'schedule',
				'error',
				);
				$controllers = array(
				'system_all_polls',
				'system_all_hosts',
				'system_all_licenses',
				'system_all_messages',
				'system_all_groups',
//				'system_all_manages',
				'system_grpset_users',
				'system_grpset_schedules',
				'system_monitor_accesslogs',
				//yuanxiaojun start 20080418
//				'system_monitor_databackups',
//				'system_monitor_datadeletes',
				//yuanxiaojun end 20080418
//				'system_monitor_works',
				//yuanxiaojun start 20080610
//				'system_monitor_folderchange',
				//yuanxiaojun end 20080610
				//			    				'system_monitor_securitys',
				'system_userinfos',
				'alerts',
				//zhangs start 20080512
				'alerts_view',
				//zhangs end 20080512
//				'securities',
				//			    				'system_all_alerts',
				'phantosys',
				'system_all_mail',
				'system_all_alert_phantosys',
				);   ///db1ff1fc73cc3609398228530eb1bd81
				/////6120E0 - 38D128 - 13717B - 6EC1F0 - 6D2D91 - AF8AB3 - 29017B - 2D5A08
				/////9037B5 - 36690A - 90AFFC - 6687EE - DCD1D9 - 618AB3 - 29017B - 2D5A08
				/////A04BFA - 5F246D - 523B7B - 6EC1F0 - 6D2D91 - AF8AB3 - 29017B - 2D5A08
				//			    				 alerts_webs
				// 17 印刷                                  alerts_prints
				// 18 ログオンアカウント                    alerts_evtusers
				// 19 デバイス                              alerts_devices
				// 20 ファイル                              alerts_files
				// 21 イベントログ                          alerts_evtlogs
				// 22 サービス                              alerts_services
				// 23 プロセス                              alerts_processes
				// 24 パターンファイル                      alerts_vptns
				// 25 アプリケーション                      alerts_apps
				if($results[1] == 0xff || (($results[4] & 0x01) != 0)){ //稼動管理  ////07F0EA - 79864A - AF48A5 - 85709F - 385953 - 478AB3 - 29017B - 2D5A08
//					$controllers[] = 'use';
//					$controllers[] = 'use_perf_hdws';
//					$controllers[] = 'use_perf_sfws';
					$controllers[] = 'use_evtlogs';
//					$controllers[] = 'use_services';
//					$controllers[] = 'use_processs';
//					$controllers[] = 'use_update_hotfixes';
//					$controllers[] = 'use_update_vptns';
//					$controllers[] = 'use_apps';
					$controllers[] = 'alerts_evtlogs';
//					$controllers[] = 'alerts_services';
//					$controllers[] = 'alerts_processes';
//					$controllers[] = 'alerts_vptns';
//					$controllers[] = 'alerts_apps';
//					$controllers[] = 'alerts_perfs';
//					$controllers[] = 'system_all_evtfils';
//					$controllers[] = 'system_all_hotfixes';
//					$controllers[] = 'system_all_vptns';
//					$controllers[] = 'system_all_procapps';
//					$controllers[] = 'system_grpset_services';
//					$controllers[] = 'system_grpset_processes';
					$controllers[] = 'system_grpset_alert_evtlogs';
//					$controllers[] = 'system_grpset_alert_services';
//					$controllers[] = 'system_grpset_alert_processes';
//					$controllers[] = 'system_grpset_alert_vptns';
//					$controllers[] = 'system_grpset_alert_apps';
//					$controllers[] = 'system_grpset_alert_perfs';
//					$modules[] = 'performance';
					$modules[] = 'event';
//					$modules[] = 'service';
//					$modules[] = 'antivirus';
//					$modules[] = 'application';
				}
				if($results[2] == 0xff || (($results[4] & 0x02) != 0)){ //資産管理





					$controllers[] = 'assets_mng_hdws';
					$controllers[] = 'assets_mng_sfws';
					$controllers[] = 'assets_apps';
					$controllers[] = 'system_grpset_assets';
					$controllers[] = 'system_grpset_apps';
					//zhangs start 20080604  
					$controllers[] = 'system_grpset_sfwssystem';
					//zhangs end 20080604
					$modules[] = 'WMI';
					$modules[] = 'application';
				}
				if($results[3] == 0xff || (($results[4] & 0x04) != 0)){//操作管理2^3
//					$controllers[] = 'oper';
					$controllers[] = 'oper_webs';
					$controllers[] = 'oper_prints';
					$controllers[] = 'oper_evtusers';
					$controllers[] = 'oper_devices';
					$controllers[] = 'alerts_webs';
					$controllers[] = 'alerts_prints';
					$controllers[] = 'alerts_evtusers';
					$controllers[] = 'alerts_devices';
					$controllers[] = 'system_grpset_alert_webs';
					$controllers[] = 'system_grpset_alert_prints';
					$controllers[] = 'system_grpset_alert_evtusers';
					$controllers[] = 'system_grpset_alert_devices';
					$modules[] = 'webaccess';
					$modules[] = 'event';
					$modules[] = 'device';
					$modules[] = 'timekeeper';
				}
				if(($results[4] & 0x20) != 0){//ファイル更新履歴2^5
					// zhangs start 20080217
					/*
					$controllers[] = 'oper_files';
					$controllers[] = 'alerts_files';
					$controllers[] = 'system_grpset_files';
					$controllers[] = 'system_grpset_alert_files';
					*/

					//$controllers[] = 'oper_files';
					//$controllers[] = 'alerts_files';
//					$controllers[] = 'system_grpset_files';
					//$controllers[] = 'system_grpset_alert_files';

//					$controllers[] = 'opt_files';
					//$controllers[] = 'opt_folders';
					//$controllers[] = 'system_monitor_grpaltfiles';
					// zhangs end 20080217
//					$modules[] = 'fileinfo';
					
					$controllers[] = 'file';
					$controllers[] = 'file_operations';
				}
				
				
				//jinl start 20080331
				if(($results[4] & 0x08) != 0){//URLカテゴリ履歴 共有 2^3
					$controllers[] = 'opu_webs';
				}
				//jinl end 20080331
				if(($results[4] & 0x40) != 0){//NETMETRIX-LogVilalge 共有 2^6
					$controllers[] = 'system_all_netmetrixes';
				}
				//			         $asso = array('Rltcodauth : rltcodauths:left'=> array('Authority.id= Rltcodauth.authority_id '),);
				//			         $fields_aut=array('Authority.controller_name') ;
				//			         $criteria_aut[]="Rltcodauth.code in (".$condition.")";
				//			         $Authoritys = $this->Authority->findByAsso($criteria_aut, $fields_aut,'Authority.id', null, null, $asso);
				//			         $Authoritys = set :: extract($Authoritys, "{n}.Authority.controller_name");
				//			         //debug($Authoritys,true);
				//			         foreach ($Authoritys as $Authority){
				
				foreach ($controllers as $Authority){
					$contr_name=md5($Authority."tail");
					$add_aut = array(
					'Someauth' => array(
					//			      'id' =>$id,
					'authoritied' => $contr_name,
					)
					);
					$this->Someauth->save($add_aut);
				}
				//---add someauths  end------
				//---add modules  start------
				//			         $asso_mod = array('Rltcodmod : rltcodmods:left'=> array('Module.id= Rltcodmod.module_id'),);
				//			         $fields_mod=array('DISTINCT(Module.module_name) AS Module__module_name') ;
				//			         $criteria_mod[]="Rltcodmod.code in (".$condition.")";
				//			         $Modules = $this->Module->findByAsso($criteria_mod, $fields_mod,null, null, null, $asso_mod);
				////			         debug($Modules);
				//			         $Modules = set :: extract($Modules, "{n}.Module.module_name");
				//			         foreach ($Modules as $Module){
				foreach ($modules as $Module){
					$Module_name=md5($Module."tail");
					$add_mod = array(
					'Somemod' => array(
					'authoritied' => $Module_name,
					)
					);
					$this->Somemod->save($add_mod);
				}
				//             ---add modules  end------
				//			   ---add user authorities start -----
				$this->uses[] = "Rltuserauth";
				$this->constructClasses();
				$controllers = $this->Authority->findAll("Authority.controller_name IN ( '" . implode("','", $controllers) . "' )");
				$authids = set :: extract($controllers, "{n}.Authority.id");
				//				var_dump($authids);
				$userId = $this->_getUserId();
				$this->Rltuserauth->deleteAll(array("1=1", "user_id = " . $userId));
				$this->Rltuserauth->deleteAll(array("user_id" => 0));

				$this->uses[] = "User";
				$this->constructClasses();
				$have0id = $this->User->findAll("User.id = 0");
				if(!empty($have0id) && $userId != 0){
					foreach ($authids as $v){
						$this->Rltuserauth->save(array("user_id" => 0, "authority_id" => $v));
					}
				}

				foreach ($authids as $v){
					$this->Rltuserauth->save(array("user_id" => $userId, "authority_id" => $v));
				}
				$this->Rltuserauth->deleteAll(array("authority_id NOT IN(" . implode(',', $authids) . ")"));
				//			   ---add user authorities end   -----
				$id=1;
				$year=$results[5];
				$day=$results[6];
				//                 debug($results,true);
				$date = date("Y/m/d", mktime(0, 0, 0, 1, $day+1, $year));
				$today = date("Y-m-d H:i:s");
				$add = array(
				'License' => array(
				'id'=>$id,
				'licence_code' =>$license_code,
				'update_time' =>$today,
				'end_time' =>$date,
				'assets' =>$results[1],
				'oper' =>$results[2],
				'`use`' =>$results[3],
				'`option`' =>$results[4],
				'customer' =>$results[9],
				'pc_num' =>$results[7],
				'ps_num' =>$results[8],
				)
				);

				$this->License->save($add);
				$this->_destroy_menu_session();
				$this->requestAction("system_grpset_schedules/lic/");
				$this->redirect("/system_all_licenses/");
			}
		}
		else {

		}
	}

	function decode($license_code)
	{
		$new_code = str_replace(" - ", "", $license_code);
		$v_path=(VENDORS);

		$tmpfname = tempnam("/tmp", "DECODE");
		rename($tmpfname, $tmpfname . ".exe");
		$tmpfname = $tmpfname . ".exe";
		copy(sprintf("%sdecode.exe", $v_path), $tmpfname);
		session_write_close();									//add by wzy at 2007-09-18 for exec() no bug
		$result = exec( sprintf("%s %s", $tmpfname,$new_code) );
		session_start();										//add by wzy at 2007-09-18 for exec() no bug
		unlink($tmpfname);

		return $result;
	}

	function check_lic()
	{
		$licenses = $this->License->findAll();
		if(!empty($licenses[0]['License']['licence_code'])){
			$result = $this->decode($licenses[0]['License']['licence_code']);
			if($result != -1){//ライセンス合法

				$results = explode(" ", $result);
				$end_time = date("Y/m/d", mktime(0, 0, 0, 1, $results[6]+1, $results[5]));

				if($end_time==date("Y/m/d", strtotime($licenses[0]['License']['end_time']))
				&& $licenses[0]['License']['assets'] == $results[1]
				&& $licenses[0]['License']['oper'] == $results[2]
				&& $licenses[0]['License']['use'] == $results[3]
				&& $licenses[0]['License']['option'] == $results[4]
				&& $licenses[0]['License']['customer'] == $results[9]
				&& $licenses[0]['License']['pc_num'] == $results[7]
				&& $licenses[0]['License']['ps_num'] == $results[8]
				){return;}//動作しない

				else {//ライセンスコード以外の情報不具合があり、コードで更新
					$update = array(
					'License' => array(
					'id'=>$licenses[0]['License']['id'],
					'licence_code' =>$licenses[0]['License']['licence_code'],
					'end_time' =>$end_time,
					'assets' =>$results[1],
					'oper' =>$results[2],
					'`use`' =>$results[3],
					'`option`' =>$results[4],
					'customer' =>$results[9],
					'pc_num' =>$results[7],
					'ps_num' =>$results[8],
					)
					);
					$this->License->save($update);
					return true;
				}
			}
		}
		//ライセンスコードの不具合があり、システム初期化へ
		$this->_init_lic();
		return false;///schedule to stop
	}
	function _init_lic()
	{
		$this->License->deleteAll(array("1=1"));

	}
	//	function decode($license_code)
	//	{
	//		 $new_code = str_replace(" - ", "", $license_code);
	//	 	 $v_path=(VENDORS);
	//	     $result = exec( sprintf("\"%sdecode.exe\" %s", $v_path,$new_code) , $data);
	//	     //var_dump($result);
	//	     //var_dump($data);
	//	     printf("%sdecode.exe %s", $v_path,$new_code);
	//	     return $result;
	//	}
}
?>